function [P,A,B]=randGraph(n)
  m=round(n+ceil(log2(n)));
  P=unique(randi(m,m,2),"rows");
  m=rows(P);
  A=greedy_nav_net(P);
  d=sum(A);
  noleafs=find(d>1);
  while (length(noleafs)<m)
    A=A(noleafs,noleafs);
    P=P(noleafs,:);
    m=rows(P);
    A=greedy_nav_net(P);
    d=sum(A);
    noleafs=find(d>1);
  endwhile;  
  if(m<n)
    [P,A,B]= randGraph(n);
  else      
    [i,j]=find(A);
    E=[i,j];    
    for i=1:rows(E) 
      E(i,:)=sort(E(i,:)); 
    endfor;
    E=unique(E,"rows");
    B=[];
    for i=1:rows(E)
      v=zeros(m,1);
      v(E(i,1))=1;
      v(E(i,2))=-1;
      B=[B,v];
    endfor;
  endif;
  if(!twoEdgeConn(B))
    [P,A,B]= randGraph(n);
  endif
endfunction